﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace IndustryConnect.Bootcamp.UnitTest
{
    [TestClass]
    public class BasicUnitTests // Right click the class name: BasicUnitTests and click Run Tests
    {
        [TestMethod]
        [ExpectedException(typeof(ArgumentException), "Invaid candidateName")]
        public void TestApplyJob_CandidateName1()
        {
            // Test to expect of an exception while candidateName is an empty string.
            var jobService = new JobService(new CvService());
            jobService.ApplyJob("", 0, "CV content goes here.. Experience...");
        }

        [TestMethod]
        [ExpectedException(typeof(ArgumentException), "Invaid candidateName")]
        public void TestApplyJob_CandidateName2()
        {
            // Test to expect of an exception while candidateName is a string with only white space.
            var jobService = new JobService(new CvService());
            jobService.ApplyJob("  ", 0, "CV content goes here.. Experience...");
        }

        [TestMethod]
        public void TestApplyJob_Experience()
        {
            var jobService = new JobService(new CvService());
            var result = jobService.ApplyJob("Mike", -1, "CV content goes here.. Experience...");
            Assert.IsFalse(result);

            // Test the result when experience level is 0
            result = jobService.ApplyJob("Mike", 0, "CV content goes here.. Experience...");
            Assert.IsFalse(result);

            // Test the result when experience level is 1
            result = jobService.ApplyJob("Mike", 1, "CV content goes here.. Experience...");
            Assert.IsTrue(result);

            // Test the result when CV does not have experience
            result = jobService.ApplyJob("Mike", 1, "CV content goes here.. XXXXXXXXXXX...");
            Assert.IsFalse(result);
        }
    }
}
